package de.mdelab.mlsdm.ui.popup.actions;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class ExtractStoryPatternsAction implements IObjectActionDelegate
{
	private final List<IFile>	inputModelFiles;

	/**
	 * Constructor for Action1.
	 */
	public ExtractStoryPatternsAction()
	{
		super();
		this.inputModelFiles = new LinkedList<IFile>();
	}

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	@Override
	public void setActivePart(final IAction action, final IWorkbenchPart targetPart)
	{
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	@Override
	public void run(final IAction action)
	{
		for (final IFile iFile : this.inputModelFiles)
		{
			final ExtractStoryPatternsJob job = new ExtractStoryPatternsJob(URI.createPlatformResourceURI(iFile.getFullPath().toString(),
					true));
			job.schedule();
		}
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	@Override
	public void selectionChanged(final IAction action, final ISelection selection)
	{
		action.setEnabled(false);

		this.inputModelFiles.clear();

		if (!(selection instanceof IStructuredSelection) || selection.isEmpty())
		{
			return;
		}

		@SuppressWarnings("rawtypes")
		final Iterator it = ((IStructuredSelection) selection).iterator();

		while (it.hasNext())
		{
			final Object o = it.next();

			if (o instanceof IFile)
			{
				this.inputModelFiles.add((IFile) o);
			}
		}

		action.setEnabled(true);
	}

}
